# Sample plugin controller
class TransfertController < ApplicationController
  require 'active_record'
  unloadable

  layout 'base'
  before_filter :find_project, :authorize

  helper :sort
  include SortHelper
  helper :issues
 
  def index
  end
  
  def no_accent(texte)
    CGI.escape(texte).gsub('+',' ').gsub('%E9','e').gsub('%27',' ').gsub('%FB','u').gsub('%2B','+').gsub('%28','(').gsub('%3B',';').gsub('%0D%0A','').gsub('%2C',',').gsub('%85','...').gsub('%29',')').gsub('%EA','e').gsub('%26','et').gsub('%3A',':').gsub('%E2','a').gsub('%E0','a').gsub('%22','').gsub('%8C','OE').gsub('%B0','um ').gsub('%E8','e')
  end
  
  def def_month(texte)
    case (texte)
      when "janv.": return "01"
      when "fevr.": return "02"
      when "mars": return "03"
      when "avr.": return "04"
      when "mai": return "05"
      when "juin": return "06"
      when "juil.": return "07"
      when "aout": return "08"
      when "sept.": return "09"
      when "oct.": return "10"
      when "nov.": return "11"
      when "dec.": return "12"
      else return texte
    end
  end
  
  def import
    @i=0
    @issue = Array.new
    @issue_old =Array.new
    @test=Array.new
    @her= Array.new
    @file=params[:fichier]
    if @file.size == 0
      flash.now[:error] = l(:notice_error_fichier)
      render :controller => 'transfert', :action => 'index'
    else
      if @file.original_filename.split('.').last != 'csv'
        flash.now[:error] = l(:notice_error_choix_csv)
        render :controller => 'transfert', :action => 'index'
      else
        flash.now[:notice] = l(:notice_ok_choix)
        @nom_court=@file.original_filename.split('.').first
        @test1=(@file.read)
        @test1.each_line { |ligne|
          if ligne != nil
            @test.push(no_accent(ligne))
          end
        }
        if @test[0] == "ID;Taches;Travail;Debut;Fin"
           @cfMsProject = CustomField.find(:all, :conditions =>{:name=>"ID Project"})
            if @cfMsProject == []
              c = IssueCustomField.new :name => "ID Project",
              :field_format  => "int",
              :possible_values => "--- []",
              :is_for_all => 1
              c.trackers=Tracker.find :all
              next unless c.save!
            end
            @cfRAF = CustomField.find(:all, :conditions =>{:name=>"RAF"})
            if @cfRAF == []
              c = IssueCustomField.new :name => "RAF",
              :field_format  => "float",
              :possible_values => "--- []",
              :is_for_all => 1
              c.trackers=Tracker.find :all
              next unless c.save!
            end
          @test.each do |ligne|
            if ligne.split(';').first != "ID"
              @uniqueID = ligne.split(';').first
              @vir=(ligne.split(';')[2]).count ","
              if @vir == 1
                @flottant=(ligne.split(';')[2].split(',').first + "." +ligne.split(';')[2].split(',').last).to_f
              else
                @flottant = (ligne.split(';')[2]).to_f
              end
              @day_due =  ligne.split(';').last.split("-").first
              @day_start = ligne.split(';')[3].split("-").first
              @year_due = "20" + ligne.split(';').last.split("-").last
              @year_start = "20" + ligne.split(';')[3].split("-").last
              @month_start=def_month(ligne.split(';')[3].split("-")[1])
              @month_due=def_month(ligne.split(';').last.split("-")[1])
              @caract1 = ligne.split(';')[1]
              @raf = (@flottant*7).to_s
              i = Issue.new :project_id => @project.id,
              :subject => @caract1,
              :author_id => 1,
              :description => @caract1,
              :tracker_id =>1,
              :due_date => @year_due + "-" + @month_due + "-" + @day_due + " 00:00:00",
              :start_date => @year_start + "-" + @month_start + "-" + @day_start + " 00:00:00",
              :estimated_hours => (@flottant*7)
              @tache_red = Issue.find(:all, :conditions =>{:project_id=>i.project_id, :subject =>@caract1,:start_date=> @year_start + "-" + @month_start + "-" + @day_start + " 00:00:00",:due_date=>@year_due + "-" + @month_due + "-" + @day_due + " 00:00:00"})
              if @tache_red == []
                next unless i.save!
                @issue.push(i)
                #~ @issue.each do |a|
                  i.custom_values.each do |b|
                    #~ @her.push(a.estimated_hours)
                    if b.custom_field.name == "RAF"
                       b.value = @raf
                       #~ b.value = "5"
                       next unless b.save!
                    else
                      if b.custom_field.name == "ID Project"
                        b.value = @uniqueID
				next unless b.save!
                      end
                    end
                    #~ next unless i.save!
                    next unless i.save!
                  end
                #~ end
              next unless i.save!
              else
                @tache_red.each do |tache|
                  i.id=tache.id
                end
                @issue_old.push(i)
              end
            end
          end
          render :controller => 'transfert',:action =>'import'
        else
          flash.now[:error] = l(:notice_error_range)
          render :controller => 'transfert', :action => 'index'
        end
      end
    end
  end

private
  def find_project
    @project=Project.find(params[:id])
  end
end
